--***************************************************************
--
-- based on dural's mrGearbox2.lua
-- 
-- version 1.0 by mogli (biedens)
-- 2014/07/14
--
--***************************************************************

mrSoundEngineFix = {} 

function mrSoundEngineFix.prerequisitesPresent(specializations) 
	return true
end 

function mrSoundEngineFix:load(xmlFile) 
end

function mrSoundEngineFix:delete()    
end 

function mrSoundEngineFix:mouseEvent(posX, posY, isDown, isUp, button)
end 

function mrSoundEngineFix:keyEvent(unicode, sym, modifier, isDown)
end 

function mrSoundEngineFix:update(dt)
	local s,r = pcall(mrSoundEngineFix.soundFix,self,dt)
	if not s then
		print(tostring(r))
	end
end

function mrSoundEngineFix:soundFix(dt)
	if      self.isServer 
			and self.realInitialized then
		if  self.realManualGearSet 
				and self.realClutchEngaged 
				and not ( self.realHydrostaticTransmission ) 
				and self.realClutchPercent                > 0
				and self.realEngine.currentGearRatedSpeed > 0 
				and self.realAvgMotorizedWheelSpd        >= 0 then
			if self.mrSEFLastEngineRevFx == nil then
				self.mrSEFMinDeltaMinus   = ( self.realEngine.ratedRpm - self.realEngine.idleRpm ) / ( self.realEngine.revDownTimeMs * self.realEngine.ratedRpm )
				self.mrSEFMinDeltaPlus    = ( self.realEngine.ratedRpm - self.realEngine.idleRpm ) / ( self.realEngine.revUpTimeMs * self.realEngine.ratedRpm )
			else
				local engineRevFx = self.realAvgMotorizedWheelSpd / self.realEngine.currentGearRatedSpeed
				engineRevFx = Utils.clamp( engineRevFx, math.min( self.mrSEFLastEngineRevFx - dt * self.mrSEFMinDeltaMinus, 1 )
																							, self.mrSEFLastEngineRevFx + dt * self.mrSEFMinDeltaPlus )
				local delta = engineRevFx * self.realEngine.currentGearRatedSpeed - self.realAvgMotorizedWheelSpd
			--print(tostring(dt).." "..tostring(engineRevFx).." "..tostring(self.mrSEFLastEngineRevFx).." "..tostring(delta / self.realEngine.currentGearRatedSpeed))
				self.realAvgMotorizedWheelSpd = self.realAvgMotorizedWheelSpd + self.realClutchPercent * delta																	
			end 
			self.mrSEFLastEngineRevFx = self.realAvgMotorizedWheelSpd / self.realEngine.currentGearRatedSpeed
		else
			self.mrSEFLastEngineRevFx = nil
		end
	end 
end 

function mrSoundEngineFix:updateTick(dt)
end 

function mrSoundEngineFix:draw() 	
end 

